Codeforces Round #301 (Div. 2)(A,【模拟】B,【贪心构造】C,【DFS】)

简介: A. Combination Lock time limit per test:2 seconds memory limit per test:256 megabytes input:standard input output:standa...

A. Combination Lock

time limit per test:2 seconds
memory limit per test:256 megabytes
input:standard input
output:standard output

Scrooge McDuck keeps his most treasured savings in a home safe with a combination lock. Each time he wants to put there the treasures that he's earned fair and square, he has to open the lock.

The combination lock is represented by n rotating disks with digits from 0 to 9 written on them. Scrooge McDuck has to turn some disks so that the combination of digits on the disks forms a secret combination. In one move, he can rotate one disk one digit forwards or backwards. In particular, in one move he can go from digit 0 to digit 9 and vice versa. What minimum number of actions does he need for that?

Input

The first line contains a single integer n (1 ≤ n ≤ 1000) — the number of disks on the combination lock.

The second line contains a string of n digits — the original state of the disks.

The third line contains a string of n digits — Scrooge McDuck's combination that opens the lock.

Output

Print a single integer — the minimum number of moves Scrooge McDuck needs to open the lock.

Examples
Input
5 
82195
64723
Output
13
Note

In the sample he needs 13 moves:

  • 1 disk:
  • 2 disk:
  • 3 disk:
  • 4 disk:
  • 5 disk:
               
题目链接:http://codeforces.com/contest/540/problem/A
题意:给你两串n个长度的密码,要你求出将第一串密码变为第二串密码所需的最小操作数!
分析:模拟一下就好了!
下面给出AC代码:
 1 #include <bits/stdc++.h>
 2 using namespace std;
 3 char a[1010],b[1010];
 4 int main()
 5 {
 6     int n;
 7     while(scanf("%d",&n)!=EOF)
 8     {
 9         cin>>a;
10         cin>>b;
11         int sum=0;
12         for(int i=0;i<n;i++)
13         {
14            if(a[i]>=b[i])
15                sum+=min(a[i]-b[i],b[i]+10-a[i]);
16            else
17                sum+=min(b[i]-a[i],a[i]+10-b[i]);
18     }
19         printf("%d\n",sum);
20     }
21     return 0;
22 }

 

B. School Marks

time limit per test:2 seconds
memory limit per test:256 megabytes
input:standard input
output:standard output

Little Vova studies programming in an elite school. Vova and his classmates are supposed to write n progress tests, for each test they will get a mark from 1 to p. Vova is very smart and he can write every test for any mark, but he doesn't want to stand out from the crowd too much. If the sum of his marks for all tests exceeds value x, then his classmates notice how smart he is and start distracting him asking to let them copy his homework. And if the median of his marks will be lower than y points (the definition of a median is given in the notes), then his mom will decide that he gets too many bad marks and forbid him to play computer games.

Vova has already wrote k tests and got marks a1, ..., ak. He doesn't want to get into the first or the second situation described above and now he needs to determine which marks he needs to get for the remaining tests. Help him do that.

Input

The first line contains 5 space-separated integers: n, k, p, x and y (1 ≤ n ≤ 999, n is odd, 0 ≤ k < n, 1 ≤ p ≤ 1000, n ≤ x ≤ n·p, 1 ≤ y ≤ p). Here n is the number of tests that Vova is planned to write, k is the number of tests he has already written, p is the maximum possible mark for a test, x is the maximum total number of points so that the classmates don't yet disturb Vova, y is the minimum median point so that mom still lets him play computer games.

The second line contains k space-separated integers: a1, ..., ak (1 ≤ ai ≤ p) — the marks that Vova got for the tests he has already written.

Output

If Vova cannot achieve the desired result, print "-1".

Otherwise, print n - k space-separated integers — the marks that Vova should get for the remaining tests. If there are multiple possible solutions, print any of them.

Examples
Input
5 3 5 18 4 
3 5 4
Output
4 1
Input
5 3 5 16 4 
5 5 5
Output
-1
Note

The median of sequence a1, ..., an where n is odd (in this problem n is always odd) is the element staying on (n + 1) / 2 position in the sorted list of ai.

In the first sample the sum of marks equals 3 + 5 + 4 + 4 + 1 = 17, what doesn't exceed 18, that means that Vova won't be disturbed by his classmates. And the median point of the sequence {1, 3, 4, 4, 5} equals to 4, that isn't less than 4, so his mom lets him play computer games.

Please note that you do not have to maximize the sum of marks or the median mark. Any of the answers: "4 2", "2 4", "5 1", "1 5", "4 1", "1 4" for the first test is correct.

In the second sample Vova got three '5' marks, so even if he gets two '1' marks, the sum of marks will be 17, that is more than the required value of 16. So, the answer to this test is "-1".

题目链接:http://codeforces.com/contest/540/problem/B

题意:有一个n个元素的序列(n为奇数),现在给出其中的k个元素,让你构造其它的n-k个元素使得该序列的中位数>=y、序列总和<=x、最大元素<=p。输出任意一种可能即可。

分析:由于中位数的区间很小,我们可以去枚举。对于当前的中位数i,我们求出小于i的元素个数l,大于i的元素个数r,等于i的元素个数cnt。除去中位数自身,对于cnt-1(前提cnt!=0),我们贪心的处理,尽可能的放在i的右边,下面就是填数使左右区间元素个数相等。显然左边填1,右边填i就可以保证序列和尽可能小。

下面给出AC代码:

 1 #include <bits/stdc++.h>
 2 using namespace std;
 3 typedef long long ll;
 4 #define INF 1ll<<60;
 5 int main()
 6 {
 7     int n,k,p,x,y;
 8     cin>>n>>k>>p>>x>>y;
 9     int sum=0,a;
10     int t1=0;//统计小于y的个数
11     int t2=0;//统计大于等于y的个数
12     int m=n-k;//剩余的标记数
13     for(int i=1;i<=k;i++)
14     {
15         cin>>a;
16         sum+=a;
17         if(a<y)
18             t1++;
19         else t2++;
20     }
21     x-=sum;//剩余的总分
22     if(x<0||t1>n/2||m>x)
23     {
24         cout<<-1<<endl;
25         return 0;
26     }
27     int cnt=(n+1)/2-t2;//判断大于y的个数是否大于总数的一半,(n+1)/2表示向上取整
28     int s=x-(n/2-t1);//最终剩余分数
29     if(cnt>0&&s/cnt<y)
30     {
31         cout<<-1<<endl;
32         return 0;
33     }
34     if(cnt<0)
35         t1=n-k;
36     else t1=(n/2)-t1;
37     for(int i=1;i<=t1;i++)
38         cout<<1<<" ";
39         t2=(n+1)/2-t2;
40     for(int i=1;i<=t2;i++)
41         cout<<y<<" ";
42     return 0;
43 }

 

C. Ice Cave

time limit per test:2 seconds
memory limit per test:256 megabytes
input:standard input
output:standard output

You play a computer game. Your character stands on some level of a multilevel ice cave. In order to move on forward, you need to descend one level lower and the only way to do this is to fall through the ice.

The level of the cave where you are is a rectangular square grid of n rows and m columns. Each cell consists either from intact or from cracked ice. From each cell you can move to cells that are side-adjacent with yours (due to some limitations of the game engine you cannot make jumps on the same place, i.e. jump from a cell to itself). If you move to the cell with cracked ice, then your character falls down through it and if you move to the cell with intact ice, then the ice on this cell becomes cracked.

Let's number the rows with integers from 1 to n from top to bottom and the columns with integers from 1 to m from left to right. Let's denote a cell on the intersection of the r-th row and the c-th column as (r, c).

You are staying in the cell (r1, c1) and this cell is cracked because you've just fallen here from a higher level. You need to fall down through the cell (r2, c2) since the exit to the next level is there. Can you do this?

Input

The first line contains two integers, n and m (1 ≤ n, m ≤ 500) — the number of rows and columns in the cave description.

Each of the next n lines describes the initial state of the level of the cave, each line consists of m characters "." (that is, intact ice) and "X" (cracked ice).

The next line contains two integers, r1 and c1 (1 ≤ r1 ≤ n, 1 ≤ c1 ≤ m) — your initial coordinates. It is guaranteed that the description of the cave contains character 'X' in cell (r1, c1), that is, the ice on the starting cell is initially cracked.

The next line contains two integers r2 and c2 (1 ≤ r2 ≤ n, 1 ≤ c2 ≤ m) — the coordinates of the cell through which you need to fall. The final cell may coincide with the starting one.

Output

If you can reach the destination, print 'YES', otherwise print 'NO'.

Examples
Input
4 6 
X...XX
...XX.
.X..X.
......
1 6
2 2
Output
YES
Input
5 4 
.X..
...X
X.X.
....
.XX.
5 3
1 1
Output
NO
Input
4 7 
..X.XX.
.XX..X.
X...X..
X......
2 2
1 6
Output
YES
Note

In the first sample test one possible path is:

After the first visit of cell (2, 2) the ice on it cracks and when you step there for the second time, your character falls through the ice as intended.

题目链接:http://codeforces.com/contest/540/problem/C

题意:

n*m的地图,'X'表示有裂痕的冰块,'.'表示完整的冰块,有裂痕的冰块再被踩一次就会碎掉,完整的冰块被踩一次会变成有裂痕的冰块,

现在告诉起点和终点,问从起点能否走到终点并且使终点的冰块碎掉。不能原地跳。起点和终点可能会在同一个位置。

分析:

在只走‘.’的情况下把终点的冰踩碎,输入n*m的矩阵以及走的开始和终点位置,在开始点,上下左右找‘.’,有就走,并把改点设置为‘X’,走到终点时候,若终点是‘X’则成功。其他情况都失败,DFS即可。

下面给出AC代码:
 1 #include <bits/stdc++.h>
 2 using namespace std;
 3 typedef long long ll;
 4 #define INF 1ll<<60;
 5 const int N=520;
 6 char dp[N][N];
 7 int a,b,x,y,n,m;
 8 int flag=1;
 9 void DFS(int i,int j)
10 {
11     if(dp[i][j]=='X')
12     {
13         if(i==x&&j==y)
14         {
15             cout<<"YES"<<endl;
16             exit(0);// exit是在调用处强行退出程序,运行一次程序就结束
17         }
18     }
19     else if(i>=0&&i<n&&j>=0&&j<m)
20     {
21         dp[i][j]='X';
22         DFS(i+1,j);
23         DFS(i-1,j);
24         DFS(i,j+1);
25         DFS(i,j-1);
26     }
27 }
28 int main()
29 {
30     while(scanf("%d%d",&n,&m)!=EOF)
31     {
32         for(int i=0;i<n;i++)
33             scanf("%s",dp[i]);
34         scanf("%d%d%d%d",&a,&b,&x,&y);
35         --a;
36         --b;
37         --x;
38         --y;
39         dp[a][b]='.';
40         DFS(a,b);
41         if(flag==1)
42         printf("NO\n");
43    }
44     return 0;
45 }

 

           
       

           

         

目录
相关文章
|
4月前
|
人工智能 算法 BI
class077 区间dp-下【算法】
class077 区间dp-下【算法】
32 0
|
4月前
|
算法
class076 区间dp-上【算法】
class076 区间dp-上【算法】
24 0
|
7月前
|
机器学习/深度学习 人工智能 BI
The Great Hero(Codeforces Round #700 (Div. 2))模拟+贪心思想和排序
The Great Hero(Codeforces Round #700 (Div. 2))模拟+贪心思想和排序
33 0
|
机器学习/深度学习 人工智能 BI
Codeforces Round #751 (Div. 2) D. Frog Traveler(bfs 优化)
Codeforces Round #751 (Div. 2) D. Frog Traveler(bfs 优化)
106 0
Codeforces Round #747 (Div. 2) D. The Number of Imposters(扩展域并查集 带权并查集)
Codeforces Round #747 (Div. 2) D. The Number of Imposters(扩展域并查集 带权并查集)
93 0
Codeforces Round #746 (Div. 2) C - Bakry and Partitioning(dfs 异或技巧 思维)
Codeforces Round #746 (Div. 2) C - Bakry and Partitioning(dfs 异或技巧 思维)
74 0
Codeforces Round #748 (Div. 3) E. Gardener and Tree(拓扑排序)
Codeforces Round #748 (Div. 3) E. Gardener and Tree(拓扑排序)
69 0
【算法题解】Codeforces Round #817 (Div. 4)题解
【算法题解】Codeforces Round #817 (Div. 4)题解
【算法题解】Codeforces Round #817 (Div. 4)题解